function dT = TpileT(eLow,demf,njcn)
% TpileT  Convert thermopile output for T-type wire
%
% Synopsis:  dT = TpileT(emfLow,demf,njcn)
%
% Input: eLow = emf of Ttype thermocouple at low temperature
%        demf = emf of thermopile
%        njcn = number of thermopile junctions
%
% Output:  dT = temperature difference across the thermopile

dT = Ttemp(eLow+demf/njcn)-Ttemp(eLow);